package ssdd.servidor;

import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;
import ssdd.comun.Codebase;
import ssdd.comun.IServidor;
import ssdd.comun.PoliticaSeguridad;

public class InicioServidor {
	public static void main(String[] args) throws Exception {		
		// Gestor de seguridad
		System.setProperty("java.security.policy", 
				PoliticaSeguridad.getLocationOfPolicyFile());
        if(System.getSecurityManager() == null) {
            System.setSecurityManager(new SecurityManager());
        }	
		// java.rmi.server.codebase
		Codebase.setCodeBase(IServidor.class);
		
		Servidor servidor = new Servidor();
		IServidor remote = (IServidor)UnicastRemoteObject.exportObject(servidor, 8888);
		
		Registry registry = LocateRegistry.getRegistry();
		registry.rebind("chat", remote);
		
		System.out.println("Chat Preparado, presione enter para terminar");
		System.in.read();
		registry.unbind("chat");
		UnicastRemoteObject.unexportObject(servidor, true);
		System.out.println("Chat cerrado");
	}
}
